/*
FS20 - Decoder
von SIGINT


FS20 - Empfnger an PC0
Ausgnge PB0 - PB3






*/


#include<avr/io.h>
#include<avr/interrupt.h>
#include<stdio.h>
#include"serial.h"
#include<stdint.h>


volatile long int ticks;
volatile long int sec;

volatile int puls_count,puls_lenght;
volatile unsigned char state,pending;

#define false 0
#define true 1



int get_data()
{
while(!pending){}
pending=false;

int out=-2;

if(puls_lenght==2){out=0;}
if(puls_lenght==3){out=1;}

return out;
}


char tab[16]={'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'};

char * itoh(int val,char *buffer)
{
char *p;
p=buffer;
*p='0';
p++;
*p='x';
p++;
*p=tab[(val>>4)&0x0f];
p++;
*p=tab[val&0x0f];
p++;
*p='\0';
return buffer;
}

char * itoa(int val,char *buffer)
{

long int tmp=1000000;
char *p;
p=buffer;
int is_leading=1;


while(tmp>0)
{
	*p=('0'+(val/tmp));
	if(*p!='0'){is_leading=0;}
	val=(val%tmp);

	if(!is_leading)
	{
		p++;
	}
	tmp/=10;
}

if(is_leading){*p='0';p++;}
*p='\0';

return buffer;
}



void init_timer()
{
TCCR2=(1<<WGM21)|(1<<CS21);
OCR2=0xc8;
TIMSK=(1<<OCIE2);
}

int main(void)
{
ticks=0;
sec=0;
state=false;
puls_count=0;
USART_init(207);
USART_puts("FS20 - Decoder\n");
USART_puts("by SIGINT\n");
char buffer[64];
init_timer();
sei();

DDRB=0xff;


while(1)
{
	int synced=false;
	int sync_count=0;
	int data=-1;

	while(!synced)
	{
		data=get_data();
		if(data<0){sync_count=0;}
		if((sync_count>22)&&(data==1)){synced=1;}
		if(data==0)
		{sync_count++;}
		else
		{sync_count=0;}

	}


get_data();

int HC1,HC2,ADR,OP,CK;
HC1=0;
HC2=0;
ADR=0;
OP=0;
CK=0;

int c;

for(c=0;c<8;c++)
{
	data=get_data();
	get_data();
	HC1=(HC1<<1);
	HC1|=(data&0x01);
}

get_data();
get_data();

for(c=0;c<8;c++)
{
	data=get_data();
	get_data();
	HC2=(HC2<<1);
	HC2|=(data&0x01);
}

get_data();
get_data();

for(c=0;c<8;c++)
{
	data=get_data();
	get_data();
	ADR=(ADR<<1);
	ADR|=(data&0x01);
}

get_data();
get_data();

for(c=0;c<8;c++)
{
	data=get_data();
	get_data();
	OP=(OP<<1);
	OP|=(data&0x01);
}


get_data();
get_data();

for(c=0;c<8;c++)
{
	data=get_data();
	get_data();
	CK=(CK<<1);
	CK|=(data&0x01);
}

get_data();
get_data();



unsigned char check=0x06;

check+=HC1;
check+=HC2;
check+=OP;
check+=ADR;

if(check==CK){
	if(HC1==87&&HC2==151)
	{
		switch(ADR)
		{
			case 0:
				if(OP==0){PORTB&=0xFE;}
				if(OP==17){PORTB|=0x01;}
				break;
			case 1:
				if(OP==0){PORTB&=0xFD;}
				if(OP==17){PORTB|=0x02;}
				break;
			case 2:
				if(OP==0){PORTB&=0xFB;}
				if(OP==17){PORTB|=0x04;}
				break;
			case 3:
				if(OP==0){PORTB&=0xF7;}
				if(OP==17){PORTB|=0x08;}
				break;
			case 255:
				if(OP==0){PORTB&=0xF0;}
				if(OP==17){PORTB|=0x0F;}
				break;
			default:
				break;

		}


	}

	USART_puts("HC1: ");
	itoh(HC1,buffer);
	USART_puts(buffer);
	USART_puts(" ");

	USART_puts("HC2: ");
	itoh(HC2,buffer);
	USART_puts(buffer);
	USART_puts(" ");

	USART_puts("ADR: ");
	itoh(ADR,buffer);
	USART_puts(buffer);
	USART_puts(" ");

	USART_puts("OP: ");
	itoh(OP,buffer);
	USART_puts(buffer);
	USART_puts("\n");
}

}

return 0;
}



ISR (SIG_OUTPUT_COMPARE2) 
{
unsigned char val;

val=PINC;
val&=0x01;

puls_count++;

if(val^state){
	puls_lenght=puls_count;
	puls_count=0;pending=1;
}

state=val;
ticks++;

if((ticks%10000)==0){
	sec++;
}

}
