#include <avr/pgmspace.h>
#include <avr/io.h>
#include <stdint.h>



void USART_init( unsigned int ubrr)
{
/* Set baud rate */
UBRRH = (unsigned char)(ubrr>>8);
UBRRL = (unsigned char)ubrr;
/* Enable receiver and transmitter */
UCSRB = (1<<RXEN)|(1<<TXEN);
/* Set frame format: 8data, 2stop bit */
UCSRC = (1<<URSEL)|(1<<USBS)|(3<<UCSZ0);
}

void USART_Transmit( unsigned char data )
{
/* Wait for empty transmit buffer */
while ( !( UCSRA & (1<<UDRE)) );
/* Put data into buffer, sends the data */
UDR = data;
}

unsigned char USART_Receive( void )
{
/* Wait for data to be received */
while ( !(UCSRA & (1<<RXC)) )
;
/* Get and return received data from buffer */
return UDR;
}



int USART_puts (char *string)
{
int count=0;
while((*string)!=0)
{
USART_Transmit(*string);
if((*string)=='\n'){USART_Transmit('\r');}
string++;
count++;
}
return count;
}


int USART_puts_len (unsigned char *string, int len)
{
int count;

for(count=0;count<=len;count++)
{
USART_Transmit(*(string+count));
}
return count;
}
